####### RCaBoCha for R 2.9.0 スクリプトファイル
#
# ishida.motohiro@gmail.com
#
# http://cms.ias.tokushima-u.ac.jp/index.php?RCaBoCha
#
###############################################
                                        #　これは UTF-8  ファイルです。
#　Windows ユーザーはこのファイル"RCaBoCha.R"と、付属のファイルすべてを
#　Shift JIS　に変換してください。


# setwd("/Users/yourName/dataRCaBoChaUnix")


   install.packages("RCaBoCha_0.20.tar.gz",    destdir=".",   repos = NULL)


   library(RCaBoCha)


# 文章を直接入力して解析


#####################################################
#
#
#          RCaBoCha() 関数
#
#
#####################################################
#　CaBoCha　の解析結果をそのまま出力

RCaBoCha("それは面白い本であった。")

## FROMAT_TREE =
##        それは---D
##         面白い-D
##     本であった。
## EOS
##    Term1  Term2    POS D1 D2
## 1   それ   それ   名詞  1  2
## 2     は     は   助詞  1  2
## 3 面白い 面白い 形容詞  2  2
## 4     本     本   名詞  3 -1
## 5     で     だ 助動詞  3 -1
## 6   あっ   ある 助動詞  3 -1
## 7     た     た 助動詞  3 -1
## 8     。     。   記号  3 -1




#####################################################
#
#
#          RCaBoChaFreq() 関数
#
#
#####################################################
## CaBoCha　の解析結果を頻度表に
#　この際、str2 で指定したタームとの係り受けを考慮．
# 指定されない場合は 否定の「ない」との係り受けを考慮

RCaBoChaFreq("それは面白い本であった。しかし、この本に比べると面白くはない。")

## string 2 = "ない" setted: length = 0 
##           Term           Pos Freq
## 1           、          記号    1
## 2           。          記号    2
## 3         ある        助動詞    1
## 4         この        連体詞    1
## 5       しかし        接続詞    1
## 6         それ          名詞    1
## 7           た        助動詞    1
## 8           だ        助動詞    1
## 9           と          助詞    1
## 10          に          助詞    1
## 11          は          助詞    1
## 12     は+ない   助詞+形容詞    1
## 13          本          名詞    2
## 14      比べる          動詞    1
## 15      面白い        形容詞    1
## 16 面白い+ない 形容詞+形容詞    1
## >

# 係り受けのタームを指定する．デフォルトは「ない」
RCaBoChaFreq("それは面白い本であった。しかし、この本に比べると面白くはない。", str2 = "は")
## string 2 = "は" setted: length = 1 
##         Term         Pos Freq
## 1         、        記号    1
## 2         。        記号    2
## 3       ある      助動詞    1
## 4       この      連体詞    1
## 5     しかし      接続詞    1
## 6    それ+は   名詞+助詞    1
## 7         た      助動詞    1
## 8         だ      助動詞    1
## 9         と        助詞    1
## 10      ない      形容詞    1
## 11        に        助詞    1
## 12        本        名詞    2
## 13    比べる        動詞    1
## 14    面白い      形容詞    1
## 15 面白い+は 形容詞+助詞    1




#####################################################
#
#
#          RCaBoChaFile() 関数
#
#
#####################################################
#　ファイルを読み込んで頻度表を作成
#　この際、str2 で指定したタームとの係り受けを考慮．
# 指定されない場合は 否定の「ない」との係り受けを考慮
# さらに 引数 rmT =c("記号","助詞") 等として対象としない品詞を指定できます


res  <- RCaBoChaFile("kumo.txt", "")

## Pos[0] =  記号 	removed 
## file = kumo.txt

res

##              Term         Pos Freq
## 1          あたり        名詞    3
## 2            あっ      感動詞    1
## 3            あの    フィラー    1
## 4            ある        動詞   10
## 5            ある      連体詞    3
## 6            あれ        名詞    1
## 7          いくら        副詞    2
## 8    いつの間にか        副詞    1
## 9            いや      接続詞    3
## 10   いらっしゃる        動詞    2
## ...
## 365        落ちる        動詞    4
## 366   落ちる+ない 動詞+助動詞    1
## 367            葉        名詞    2
## 368            蓮        名詞    4
## 369          蓮池        名詞    4
## 370          蔽う        動詞    1
## 371            蕊        名詞    2
## 372            蛙        名詞    1
## 373          蜘蛛        名詞   14
## 374            蟻        名詞    1
## 375          蠢く        動詞    1
## 376            血        名詞    1
## 377        血の池        名詞    7

res  <- RCaBoChaFile("kumo.txt", "の")
res
 
##             Term         Pos Freq
## 1         あたり        名詞    3
## 2           あっ      感動詞    1
## 3           あの    フィラー    1
## 4           ある        動詞    9
## 5           ある      連体詞    3
## 6        ある+の   動詞+名詞    1
## 7        あれ+の   名詞+助詞    1
## 8         いくら        副詞    2
## 9   いつの間にか        副詞    1
## 10          いや      接続詞    3
## ... 

res  <- RCaBoChaFile("kumo.txt", rmT =c("記号","助詞") )
res

## 1          あたり        名詞    3
## 2            あっ      感動詞    1
## 3            あの    フィラー    1
## ...
## 399          違い        名詞    1
## 400     違い+ない 名詞+助動詞    1
## ...











#####################################################
#
#
#          RCaBoChaDF() 関数
#
#
#####################################################
## データフレームから文書ターム行列を作成する。

#　この際、否定の「ない」との係り受けを考慮
# 引数 rmT =c("記号","助詞")等として対象としない品詞を指定できます
#　引数 minFreq で文書全体を通しての最小頻度を指定できます


dat <- read.csv("H18koe.csv")  ## 沖縄観光についての自由意見
res <- RCaBoChaDF(dat[,"opinion"])
nrow(res)
 # head(res)
res[48:53, 1:4]

##             Term         Pos OBS.3 OBS.4
## 48      あまりに        副詞     0     0
## 49      あらゆる      連体詞     0     0
## 50 ありえる+ない 動詞+助動詞     0     0
## 51    ありがたい      形容詞     0     0
## 52    ありがとう      感動詞     0     0
## 53    ありのまま        副詞     0     0
## ...

res <- RCaBoChaDF(dat[,"opinion"], str2 = "は" )
nrow(res)
 # head(res)
res[1000:1005, c(1,2, 23:28)]

##             Term       Pos OBS.23 OBS.24 OBS.25 OBS.26 OBS.27 OBS.28
## 1000    取り組み      名詞      0      0      0      0      1      0
## 1001    取り組む      動詞      0      0      0      0      0      0
## 1002 取り組む+は 動詞+助詞      0      0      0      0      0      0
## 1003        取る      動詞      0      0      0      0      0      0
## 1004      取れる      動詞      0      0      0      0      0      0
## 1005      受ける      動詞      0      0      0      0      0      0

res <- RCaBoChaDF(dat[,"opinion"],rmT =c("記号","助詞"))
nrow(res)
res[1500:1505, c(1,2, 60:65)]

##               Term         Pos OBS.60 OBS.61 OBS.62 OBS.63 OBS.64 OBS.65
## 1500      無くなる        動詞      0      0      0      0      0      0
## 1501 無くなる+ない 動詞+助動詞      0      0      0      0      0      0
## 1502        無愛想        名詞      0      0      0      0      0      0
## 1503          無料        名詞      0      0      0      0      0      0
## 1504          無理        名詞      0      0      0      0      0      1
## 1505          無駄        名詞      0      0      0      0      0      0



res <- RCaBoChaDF(dat[,"opinion"], rmT =c("記号","助詞"), minFreq = 2)
nrow(res)
res[100:110, 1:8]

##          Term           Pos OBS.3 OBS.4 OBS.5 OBS.6 OBS.7 OBS.8
## 100      たい        助動詞     0     0     0     1     0     0
## 101  たくさん          名詞     0     0     0     0     0     0
## 102      ただ        接続詞     0     0     0     0     0     0
## 103      たち          名詞     0     0     0     1     0     0
## 104      たび          名詞     0     0     0     0     0     0
## 105    たむろ          名詞     0     0     0     0     0     0
## 106      ため          名詞     0     0     1     0     0     0
## 107        だ        助動詞     0     0     0     0     2     0
## 108   だ+ない 助動詞+助動詞     0     0     0     0     0     0
## 109   だ+ない 助動詞+形容詞     0     0     0     0     0     0
## 110 だい+ない   名詞+形容詞     0     0     0     0     0     0



#####################################################
#
#
#          RCaBoChaMx() 関数
#
#
#####################################################
##　ファイルあるいはディレクトリから文書ターム行列を作成。
#　この際、否定の「ない」との係り受けを考慮
# 引数 rmT =c("記号","助詞")等として対象としない品詞を指定できます
#　さらに引数 minFreq で文書全体を通しての最小頻度をしてできます

res <- RCaBoChaMx("flower")
## file_name =  flower/hana1.txt opened
## file_name =  flower/hana2.txt opened
## file_name =  flower/hana3.txt opened
## file_name =  flower/hana4.txt opened
## file_name =  flower/hana5.txt opened

nrow(res)
 res

##         Term           Pos hana1.txt hana2.txt hana3.txt hana4.txt hana5.txt
## 1       あの        連体詞         0         0         1         0         0
## 2         う        助動詞         0         0         0         0         1
## 3         が          助詞         0         0         0         1         0
## 4       この        連体詞         0         1         0         0         0
## 5       その        連体詞         1         0         0         0         0
## 6         だ        助動詞         0         1         0         1         2
## 7    だ+ない 助動詞+助動詞         1         0         0         0         0
## 8    だ+ない 助動詞+形容詞         0         0         1         0         0
## 9         な          助詞         0         0         0         1         0
## 10        の          名詞         0         0         0         0         1
## 11        は          助詞         1         1         0         0         1
## 12   は+ない   助詞+形容詞         0         0         1         0         0
## 13        も          助詞         0         0         1         0         0
## 14  やっぱり          副詞         0         0         0         1         0
## 15      バラ          名詞         0         0         0         1         0
## 16        桜          名詞         0         0         0         0         1
## 17      綺麗          名詞         0         1         0         1         1
## 18 綺麗+ない   名詞+助動詞         1         0         0         0         0
## 19 綺麗+ない   名詞+形容詞         0         0         1         0         0
## 20        花          名詞         1         1         1         0         0




res <- RCaBoChaMx("flower", "は")
res

       Term         Pos hana1.txt hana2.txt hana3.txt hana4.txt hana5.txt
1      あの      連体詞         0         0         1         0         0
2        う      助動詞         0         0         0         0         1
3        が        助詞         0         0         0         1         0
4      この      連体詞         0         1         0         0         0
5      その      連体詞         1         0         0         0         0
6        だ      助動詞         1         1         0         1         1
7     だ+は 助動詞+助詞         0         0         1         0         1
8        な        助詞         0         0         0         1         0
9      ない      助動詞         1         0         0         0         0
10     ない      形容詞         0         0         1         0         0
11    の+は   名詞+助詞         0         0         0         0         1
12       も        助詞         0         0         1         0         0
13 やっぱり        副詞         0         0         0         1         0
14     バラ        名詞         0         0         0         1         0
15       桜        名詞         0         0         0         0         1
16     綺麗        名詞         1         1         0         1         0
17  綺麗+は   名詞+助詞         0         0         1         0         1
18       花        名詞         0         0         1         0         0
19    花+は   名詞+助詞         1         1         0         0         0


res <- RCaBoChaMx("flower", rmT = "名詞")
res

##        Term           Pos hana1.txt hana2.txt hana3.txt hana4.txt hana5.txt
## 1        。          記号         0         0         1         0         0
## 2      あの        連体詞         0         0         1         0         0
## 3        う        助動詞         0         0         0         0         1
## 4        が          助詞         0         0         0         1         0
## 5      この        連体詞         0         1         0         0         0
## 6      その        連体詞         1         0         0         0         0
## 7        だ        助動詞         0         1         0         1         2
## 8   だ+ない 助動詞+助動詞         1         0         0         0         0
## 9   だ+ない 助動詞+形容詞         0         0         1         0         0
## 10       な          助詞         0         0         0         1         0
## 11       は          助詞         1         1         0         0         1
## 12  は+ない   助詞+形容詞         0         0         1         0         0
## 13       も          助詞         0         0         1         0         0
## 14 やっぱり          副詞         0         0         0         1         0
## 15       ．          記号         1         1         0         1         1


#################################################################
#
#
#   RCaBoChaCnt() 関数
#
#
#################################################################
## 指定された単独ファイルを対象に，文の数，その文中の単語と品詞，文中の単語数，句数をまとめたデータフレームを返す．列名はそれぞれ
# totalNo = 文頭からの語数 
# SentNo  = 文番号 
# TermNo  = 文中単語番号 
# Term    = 単語 
# Pos     = 品詞 
# CharN   = その文字数 
# Cid     = 文中の句番号

res <- RCaBoChaCnt("kumo.txt" )
res[1:20,]

##    totalNo SentNo TermNo   Term    Pos CharN Cid
## 1        1      1      1   ある 連体詞     2   1
## 2        2      1      2     日   名詞     1   2
## 3        3      1      3     の   助詞     1   2
## 4        4      1      4     事   名詞     1   3
## 5        5      1      5     で 助動詞     1   3
## 6        6      1      6 ござい 助動詞     3   3
## 7        7      1      7   ます 助動詞     2   3
## 8        8      1      1     。   記号     1   1
## 9        9      2      1     御 接頭詞     1   1
## 10      10      2      2   釈迦   名詞     2   1
## 11      11      2      3     様   名詞     1   1
## 12      12      2      4     は   助詞     1   1
## 13      13      2      5   極楽   名詞     2   2
## 14      14      2      6     の   助詞     1   2
## 15      15      2      7   蓮池   名詞     2   3
## 16      16      2      8     の   助詞     1   3
## 17      17      2      9   ふち   名詞     2   4
## 18      18      2     10     を   助詞     1   4
## 19      19      2     11     、   記号     1   4
## 20      20      2     12   独り   名詞     2   5
## > 
